/**
 * generated by Xtext 2.27.0
 */
package no.hal.quiz.xtext.formatting2;

import com.google.inject.Inject;
import java.util.Arrays;
import no.hal.quiz.AbstractQA;
import no.hal.quiz.AbstractQuizPart;
import no.hal.quiz.Quiz;
import no.hal.quiz.QuizPart;
import no.hal.quiz.xtext.services.QuizDSLGrammarAccess;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class QuizDSLFormatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private QuizDSLGrammarAccess _quizDSLGrammarAccess;
  
  protected void _format(final Quiz quiz, @Extension final IFormattableDocument document) {
    EList<AbstractQuizPart> _parts = quiz.getParts();
    for (final AbstractQuizPart abstractQuizPart : _parts) {
      document.<AbstractQuizPart>format(abstractQuizPart);
    }
  }
  
  protected void _format(final QuizPart quizPart, @Extension final IFormattableDocument document) {
    EList<AbstractQA> _questions = quizPart.getQuestions();
    for (final AbstractQA abstractQA : _questions) {
      document.<AbstractQA>format(abstractQA);
    }
  }
  
  public void format(final Object quizPart, final IFormattableDocument document) {
    if (quizPart instanceof XtextResource) {
      _format((XtextResource)quizPart, document);
      return;
    } else if (quizPart instanceof QuizPart) {
      _format((QuizPart)quizPart, document);
      return;
    } else if (quizPart instanceof Quiz) {
      _format((Quiz)quizPart, document);
      return;
    } else if (quizPart instanceof EObject) {
      _format((EObject)quizPart, document);
      return;
    } else if (quizPart == null) {
      _format((Void)null, document);
      return;
    } else if (quizPart != null) {
      _format(quizPart, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(quizPart, document).toString());
    }
  }
}
